routes/web.php
<?php

use App\Http\Controllers\AuthController;
use Illuminate\Support\Facades\Route;
use App\Http\Controllers\NoteController;
use App\Http\Controllers\TaskController;
use App\Http\Controllers\CategoryController;

Route::group(['middleware' => 'auth'], function () {
    Route::get('/', function () {
        return view('welcome');
    })->name('home');

    // Categories
    Route::resource('categories', CategoryController::class);

    // Notes
    Route::resource('notes', NoteController::class);

    // Tasks`
    Route::resource('tasks', TaskController::class);


    // Logout
    Route::get('logout', [AuthController::class, 'logout'])->name('logout');
});

Route::group(['middleware' => 'guest'], function () {
    Route::get('login', [AuthController::class, 'login'])->name('login');
    Route::post('signin', [AuthController::class, 'signin'])->name('signin');
    Route::get('register', [AuthController::class, 'register'])->name('register');
    Route::post('signup', [AuthController::class, 'signup'])->name('singup');
});

app/Models/Task.php
<?php

namespace App\Models;

use App\Models\User;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Task extends Model
{
    use HasFactory;

    protected $fillable = [
        'user_id',
        'name',
        'position',
        'done',
    ];

    protected $casts = [
        'done' => 'boolean',
    ];

    public function markAsDone(): void
    {
        $this->done = true;
        $this->save();
    }

    public function markAsUndone(): void
    {
        $this->update(['done' => false]);
    }

    public function user()
    {
        return $this->belongsTo(User::class);
    }
}

app/Http/Controllers/TaskController.php
<?php

namespace App\Http\Controllers;

use App\Models\Task;
use App\Models\User;
use Illuminate\Http\Request;
use Illuminate\Validation\Rule;
use Illuminate\Support\Facades\Auth;
use App\Http\Requests\StoreTaskRequest;

class TaskController extends Controller
{
    public function __construct()
    {
        $this->authorizeResource(Task::class, 'task');
    }

    public function index()
    {
        $user = Auth::user();

        $tasks = $user->tasks()->orderBy('position')->paginate(10);

        return view('tasks/index', [
            'tasks' => $tasks,
        ]);
    }

    public function show(Task $task)
    {
        return view('tasks/show', [
            'task' => $task,
        ]);
    }

    public function edit(Task $task)
    {
        return view('tasks/edit', [
            'task' => $task,
        ]);
    }

    public function create()
    {
        return view('tasks/create');
    }

    public function destroy(Task $task)
    {
        $task->delete();

        return to_route('tasks.index');
    }

    public function store(StoreTaskRequest $request)
    {
        $user = Auth::user();

        $data = $request->validated();

        $data['done'] = $request->has('done');

        $user->tasks()->create($data);

        return to_route('tasks.index');
    }

    public function update(Request $request, Task $task)
    {
        $user = Auth::user();

        $data = $request->validate([
            'name' => [
                'required',
                Rule::unique('tasks')->where(function ($query) use ($user) {
                    return $query->where('user_id', $user->id);
                })->ignore($task->id),
            ],
            'position' => 'required|integer',
        ]);

        $task['done'] = $request->has('done');

        $task->update($data);

        return to_route('tasks.index');
    }
}

resources/views/tasks/create.blade.php
@extends('layout')

@section('title', 'Create Task')

@section('body')

@include('partials/top-nav', [
    'title' => 'Tasks'
])

@include('partials/errors')

    <form action="{{ route('tasks.store') }}" method="post">
        @csrf()
        <label for="name">Name</label>
        <input type="text" name="name" id="name" autofocus>

        <label for="position">Position</label>
        <input type="number" name="position" id="position">

        <label for="done">Done</label>
        <input type="checkbox" name="done" id="done">

        <br />
        <br />

        <input type="reset" value="Rest" style="float: left;">
        <input type="submit" value="Create">
    </form>
@endsection

resources/views/tasks/edit.blade.php
@extends('layout')

@section('title', 'Edit Task')

@section('links')
<a href="{{ route('tasks.show', ['task' => $task['id']]) }}">View</a> |
<form class="delete-form" method="post" action="{{ route('tasks.destroy', ['task' => $task['id']]) }}">
    @method('DELETE')
    @csrf()

    <input class="delete-btn" type="submit" value="Delete">
</form>
@endsection

@section('body')

@include('partials/top-nav', [
    'title' => 'Tasks'
])

@include('partials/errors')

<form action="{{ route('tasks.update', ['task' => $task['id']]) }}" method="post">
    @method('PUT')
    @csrf()
    <label for="name">Name</label>
    <input type="text" name="name" id="name" value="{{ $task['name'] }}">

    <label for="position">Position</label>
    <input type="number" name="position" id="position" value="{{ $task['position'] }}">

    <label for="done">Done</label>
    <input type="checkbox" name="done" id="done" value="{{ $task['done'] }}" {{ $task['done'] ? 'checked' : '' }}>

    <br />
    <br />

    <input type="submit" value="Update" style="float: left;">
    <input type="reset" value="Reset" >
</form>

@endsection

resources/views/tasks/index.blade.php
@extends('layout')

@section('title', 'All Tasks')

@section('links')
<a href="{{ route('tasks.create') }}">New Task</a>
@endsection

@section('body')
    @include('partials/top-nav', [
        'title' => 'Tasks'
    ])


    <table>
        <tr>
            <th>ID</th>
            <th>Name</th>
            <th>Position</th>
            <th>Done</th>
            <th>Actions</th>
        </tr>
        @foreach ($tasks as $task)
        <tr>
            <td>{{ $task['id'] }}</td>
            <td>{{ str_limit($task['name'], 10) }}</td>
            <td>{{ $task['position'] }}</td>
            <td>{{ $task['done'] ? '✅' : '❌' }}</td>
            <td>
                <a href="<?= route('tasks.edit', [
                    'task' => $task['id']
                ]) ?>">Edit</a> |
                <a href="<?= route('tasks.show', [
                    'task' => $task['id']
                ]) ?>">View</a> |

                <form class="delete-form" method="post" action="<?= route('tasks.destroy', [
                    'task' => $task['id']
                ]) ?>">
                    @method('DELETE')
                    @csrf()

                    <input class="delete-btn" type="submit" value="Delete">
                </form>
            </td>
        </tr>
        @endforeach

    </table>

    {{ $tasks->links() }}
@endsection

resources/views/tasks/show.blade.php
@extends('layout')

@section('title', 'View Task')

@section('links')
<a href="{{ route('tasks.edit', ['task' => $task['id']]) }}">Edit</a> |
<form class="delete-form" method="post" action="{{ route('tasks.destroy', ['task' => $task['id']]) }}">
    @method('DELETE')
    @csrf()

    <input class="delete-btn" type="submit" value="Delete">
</form>
@endsection

@section('body')
    @include('partials/top-nav', [
        'title' => 'Tasks'
    ])
    <div>
        <h3>Name</h3>
        {{ $task['name'] }}

        <h3>Position</h3>
        {{ $task['position'] }}

        <h3>Done</h3>
        {{ $task['done'] ? '✅' : '❌' }}

    </div>
@endsection